<?xml version="1.0" encoding="utf-8"?>
<edmx:Edmx Version="4.0" xmlns:edmx="http://docs.oasis-open.org/odata/ns/edmx">
    <edmx:Reference Uri="https://sap.github.io/odata-vocabularies/vocabularies/Common.xml">
        <edmx:Include Alias="Common" Namespace="com.sap.vocabularies.Common.v1"/>
    </edmx:Reference>
    <edmx:Reference Uri="https://oasis-tcs.github.io/odata-vocabularies/vocabularies/Org.OData.Core.V1.xml">
        <edmx:Include Alias="Core" Namespace="Org.OData.Core.V1"/>
    </edmx:Reference>
    <edmx:Reference Uri="https://sap.github.io/odata-vocabularies/vocabularies/UI.xml">
        <edmx:Include Alias="UI" Namespace="com.sap.vocabularies.UI.v1"/>
    </edmx:Reference>
    <edmx:DataServices>
        <Schema Namespace="CatalogService" xmlns="http://docs.oasis-open.org/odata/ns/edm">
            <EntityContainer Name="EntityContainer">
                <EntitySet Name="Users" EntityType="CatalogService.Users">
                    <NavigationPropertyBinding Path="Books" Target="Users2Books"/>
                    <NavigationPropertyBinding Path="SiblingEntity" Target="Users"/>
                </EntitySet>
                <EntitySet Name="Books" EntityType="CatalogService.Books">
                    <NavigationPropertyBinding Path="Author" Target="Authors"/>
                    <NavigationPropertyBinding Path="SiblingEntity" Target="Books"/>
                </EntitySet>
                <EntitySet Name="Authors" EntityType="CatalogService.Authors">
                    <NavigationPropertyBinding Path="Books" Target="Authors2Books"/>
                    <NavigationPropertyBinding Path="SiblingEntity" Target="Authors"/>
                </EntitySet>
                <EntitySet Name="Users2Books" EntityType="CatalogService.Users2Books">
                    <NavigationPropertyBinding Path="user" Target="Users"/>
                    <NavigationPropertyBinding Path="book" Target="Books"/>
                    <NavigationPropertyBinding Path="SiblingEntity" Target="Users2Books"/>
                </EntitySet>
                <EntitySet Name="Authors2Books" EntityType="CatalogService.Authors2Books">
                    <NavigationPropertyBinding Path="author" Target="Authors"/>
                    <NavigationPropertyBinding Path="book" Target="Books"/>
                    <NavigationPropertyBinding Path="SiblingEntity" Target="Authors2Books"/>
                </EntitySet>
            </EntityContainer>
            <EntityType Name="Users">
                <Key>
                    <PropertyRef Name="ID"/>
                    <PropertyRef Name="IsActiveEntity"/>
                </Key>
                <Property Name="ID" Type="Edm.Guid" Nullable="false"/>
                <Property Name="name" Type="Edm.String"/>
                <Property Name="surname" Type="Edm.String"/>
                <NavigationProperty Name="Books" Type="Collection(CatalogService.Users2Books)" Partner="user">
                    <OnDelete Action="Cascade"/>
                </NavigationProperty>
                <Property Name="IsActiveEntity" Type="Edm.Boolean" Nullable="false" DefaultValue="true"/>
                <Property Name="HasActiveEntity" Type="Edm.Boolean" Nullable="false" DefaultValue="false"/>
                <Property Name="HasDraftEntity" Type="Edm.Boolean" Nullable="false" DefaultValue="false"/>
                <NavigationProperty Name="DraftAdministrativeData" Type="CatalogService.DraftAdministrativeData" ContainsTarget="true"/>
                <NavigationProperty Name="SiblingEntity" Type="CatalogService.Users"/>
            </EntityType>
            <EntityType Name="Books">
                <Key>
                    <PropertyRef Name="ID"/>
                    <PropertyRef Name="IsActiveEntity"/>
                </Key>
                <Property Name="ID" Type="Edm.Guid" Nullable="false"/>
                <Property Name="title" Type="Edm.String"/>
                <NavigationProperty Name="Author" Type="CatalogService.Authors">
                    <ReferentialConstraint Property="Author_ID" ReferencedProperty="ID"/>
                </NavigationProperty>
                <Property Name="Author_ID" Type="Edm.Guid"/>
                <Property Name="IsActiveEntity" Type="Edm.Boolean" Nullable="false" DefaultValue="true"/>
                <Property Name="HasActiveEntity" Type="Edm.Boolean" Nullable="false" DefaultValue="false"/>
                <Property Name="HasDraftEntity" Type="Edm.Boolean" Nullable="false" DefaultValue="false"/>
                <NavigationProperty Name="DraftAdministrativeData" Type="CatalogService.DraftAdministrativeData" ContainsTarget="true"/>
                <NavigationProperty Name="SiblingEntity" Type="CatalogService.Books"/>
            </EntityType>
            <EntityType Name="Authors">
                <Key>
                    <PropertyRef Name="ID"/>
                    <PropertyRef Name="IsActiveEntity"/>
                </Key>
                <Property Name="ID" Type="Edm.Guid" Nullable="false"/>
                <Property Name="name" Type="Edm.String"/>
                <Property Name="surname" Type="Edm.String"/>
                <NavigationProperty Name="Books" Type="Collection(CatalogService.Authors2Books)" Partner="author">
                    <OnDelete Action="Cascade"/>
                </NavigationProperty>
                <Property Name="IsActiveEntity" Type="Edm.Boolean" Nullable="false" DefaultValue="true"/>
                <Property Name="HasActiveEntity" Type="Edm.Boolean" Nullable="false" DefaultValue="false"/>
                <Property Name="HasDraftEntity" Type="Edm.Boolean" Nullable="false" DefaultValue="false"/>
                <NavigationProperty Name="DraftAdministrativeData" Type="CatalogService.DraftAdministrativeData" ContainsTarget="true"/>
                <NavigationProperty Name="SiblingEntity" Type="CatalogService.Authors"/>
            </EntityType>
            <EntityType Name="Users2Books">
                <Key>
                    <PropertyRef Name="ID"/>
                    <PropertyRef Name="IsActiveEntity"/>
                </Key>
                <Property Name="ID" Type="Edm.Guid" Nullable="false"/>
                <NavigationProperty Name="user" Type="CatalogService.Users" Partner="Books">
                    <ReferentialConstraint Property="user_ID" ReferencedProperty="ID"/>
                </NavigationProperty>
                <Property Name="user_ID" Type="Edm.Guid"/>
                <NavigationProperty Name="book" Type="CatalogService.Books">
                    <ReferentialConstraint Property="book_ID" ReferencedProperty="ID"/>
                </NavigationProperty>
                <Property Name="book_ID" Type="Edm.Guid"/>
                <Property Name="quantity" Type="Edm.Int32"/>
                <Property Name="createdAt" Type="Edm.DateTimeOffset" Precision="7"/>
                <Property Name="IsActiveEntity" Type="Edm.Boolean" Nullable="false" DefaultValue="true"/>
                <Property Name="HasActiveEntity" Type="Edm.Boolean" Nullable="false" DefaultValue="false"/>
                <Property Name="HasDraftEntity" Type="Edm.Boolean" Nullable="false" DefaultValue="false"/>
                <NavigationProperty Name="DraftAdministrativeData" Type="CatalogService.DraftAdministrativeData" ContainsTarget="true"/>
                <NavigationProperty Name="SiblingEntity" Type="CatalogService.Users2Books"/>
            </EntityType>
            <EntityType Name="Authors2Books">
                <Key>
                    <PropertyRef Name="ID"/>
                    <PropertyRef Name="IsActiveEntity"/>
                </Key>
                <Property Name="ID" Type="Edm.Guid" Nullable="false"/>
                <NavigationProperty Name="author" Type="CatalogService.Authors" Partner="Books">
                    <ReferentialConstraint Property="author_ID" ReferencedProperty="ID"/>
                </NavigationProperty>
                <Property Name="author_ID" Type="Edm.Guid"/>
                <NavigationProperty Name="book" Type="CatalogService.Books">
                    <ReferentialConstraint Property="book_ID" ReferencedProperty="ID"/>
                </NavigationProperty>
                <Property Name="book_ID" Type="Edm.Guid"/>
                <Property Name="publishedAt" Type="Edm.DateTimeOffset" Precision="7"/>
                <Property Name="IsActiveEntity" Type="Edm.Boolean" Nullable="false" DefaultValue="true"/>
                <Property Name="HasActiveEntity" Type="Edm.Boolean" Nullable="false" DefaultValue="false"/>
                <Property Name="HasDraftEntity" Type="Edm.Boolean" Nullable="false" DefaultValue="false"/>
                <NavigationProperty Name="DraftAdministrativeData" Type="CatalogService.DraftAdministrativeData" ContainsTarget="true"/>
                <NavigationProperty Name="SiblingEntity" Type="CatalogService.Authors2Books"/>
            </EntityType>
            <EntityType Name="DraftAdministrativeData">
                <Key>
                    <PropertyRef Name="DraftUUID"/>
                </Key>
                <Property Name="DraftUUID" Type="Edm.Guid" Nullable="false"/>
                <Property Name="CreationDateTime" Type="Edm.DateTimeOffset" Precision="7"/>
                <Property Name="CreatedByUser" Type="Edm.String" MaxLength="256"/>
                <Property Name="DraftIsCreatedByMe" Type="Edm.Boolean"/>
                <Property Name="LastChangeDateTime" Type="Edm.DateTimeOffset" Precision="7"/>
                <Property Name="LastChangedByUser" Type="Edm.String" MaxLength="256"/>
                <Property Name="InProcessByUser" Type="Edm.String" MaxLength="256"/>
                <Property Name="DraftIsProcessedByMe" Type="Edm.Boolean"/>
            </EntityType>
            <Action Name="draftPrepare" IsBound="true" EntitySetPath="in">
                <Parameter Name="in" Type="CatalogService.Users"/>
                <Parameter Name="SideEffectsQualifier" Type="Edm.String"/>
                <ReturnType Type="CatalogService.Users"/>
            </Action>
            <Action Name="draftPrepare" IsBound="true" EntitySetPath="in">
                <Parameter Name="in" Type="CatalogService.Books"/>
                <Parameter Name="SideEffectsQualifier" Type="Edm.String"/>
                <ReturnType Type="CatalogService.Books"/>
            </Action>
            <Action Name="draftPrepare" IsBound="true" EntitySetPath="in">
                <Parameter Name="in" Type="CatalogService.Authors"/>
                <Parameter Name="SideEffectsQualifier" Type="Edm.String"/>
                <ReturnType Type="CatalogService.Authors"/>
            </Action>
            <Action Name="draftPrepare" IsBound="true" EntitySetPath="in">
                <Parameter Name="in" Type="CatalogService.Users2Books"/>
                <Parameter Name="SideEffectsQualifier" Type="Edm.String"/>
                <ReturnType Type="CatalogService.Users2Books"/>
            </Action>
            <Action Name="draftPrepare" IsBound="true" EntitySetPath="in">
                <Parameter Name="in" Type="CatalogService.Authors2Books"/>
                <Parameter Name="SideEffectsQualifier" Type="Edm.String"/>
                <ReturnType Type="CatalogService.Authors2Books"/>
            </Action>
            <Action Name="draftActivate" IsBound="true" EntitySetPath="in">
                <Parameter Name="in" Type="CatalogService.Users"/>
                <ReturnType Type="CatalogService.Users"/>
            </Action>
            <Action Name="draftActivate" IsBound="true" EntitySetPath="in">
                <Parameter Name="in" Type="CatalogService.Books"/>
                <ReturnType Type="CatalogService.Books"/>
            </Action>
            <Action Name="draftActivate" IsBound="true" EntitySetPath="in">
                <Parameter Name="in" Type="CatalogService.Authors"/>
                <ReturnType Type="CatalogService.Authors"/>
            </Action>
            <Action Name="draftEdit" IsBound="true" EntitySetPath="in">
                <Parameter Name="in" Type="CatalogService.Users"/>
                <Parameter Name="PreserveChanges" Type="Edm.Boolean"/>
                <ReturnType Type="CatalogService.Users"/>
            </Action>
            <Action Name="draftEdit" IsBound="true" EntitySetPath="in">
                <Parameter Name="in" Type="CatalogService.Books"/>
                <Parameter Name="PreserveChanges" Type="Edm.Boolean"/>
                <ReturnType Type="CatalogService.Books"/>
            </Action>
            <Action Name="draftEdit" IsBound="true" EntitySetPath="in">
                <Parameter Name="in" Type="CatalogService.Authors"/>
                <Parameter Name="PreserveChanges" Type="Edm.Boolean"/>
                <ReturnType Type="CatalogService.Authors"/>
            </Action>
            <Annotations Target="CatalogService.EntityContainer/Users">
                <Annotation Term="Common.DraftRoot">
                    <Record Type="Common.DraftRootType">
                        <PropertyValue Property="ActivationAction" String="CatalogService.draftActivate"/>
                        <PropertyValue Property="EditAction" String="CatalogService.draftEdit"/>
                        <PropertyValue Property="PreparationAction" String="CatalogService.draftPrepare"/>
                    </Record>
                </Annotation>
            </Annotations>
            <Annotations Target="CatalogService.Users/IsActiveEntity">
                <Annotation Term="UI.Hidden" Bool="true"/>
            </Annotations>
            <Annotations Target="CatalogService.Users/HasActiveEntity">
                <Annotation Term="UI.Hidden" Bool="true"/>
            </Annotations>
            <Annotations Target="CatalogService.Users/HasDraftEntity">
                <Annotation Term="UI.Hidden" Bool="true"/>
            </Annotations>
            <Annotations Target="CatalogService.Users/DraftAdministrativeData">
                <Annotation Term="UI.Hidden" Bool="true"/>
            </Annotations>
            <Annotations Target="CatalogService.EntityContainer/Books">
                <Annotation Term="Common.DraftRoot">
                    <Record Type="Common.DraftRootType">
                        <PropertyValue Property="ActivationAction" String="CatalogService.draftActivate"/>
                        <PropertyValue Property="EditAction" String="CatalogService.draftEdit"/>
                        <PropertyValue Property="PreparationAction" String="CatalogService.draftPrepare"/>
                    </Record>
                </Annotation>
            </Annotations>
            <Annotations Target="CatalogService.Books/IsActiveEntity">
                <Annotation Term="UI.Hidden" Bool="true"/>
            </Annotations>
            <Annotations Target="CatalogService.Books/HasActiveEntity">
                <Annotation Term="UI.Hidden" Bool="true"/>
            </Annotations>
            <Annotations Target="CatalogService.Books/HasDraftEntity">
                <Annotation Term="UI.Hidden" Bool="true"/>
            </Annotations>
            <Annotations Target="CatalogService.Books/DraftAdministrativeData">
                <Annotation Term="UI.Hidden" Bool="true"/>
            </Annotations>
            <Annotations Target="CatalogService.EntityContainer/Authors">
                <Annotation Term="Common.DraftRoot">
                    <Record Type="Common.DraftRootType">
                        <PropertyValue Property="ActivationAction" String="CatalogService.draftActivate"/>
                        <PropertyValue Property="EditAction" String="CatalogService.draftEdit"/>
                        <PropertyValue Property="PreparationAction" String="CatalogService.draftPrepare"/>
                    </Record>
                </Annotation>
            </Annotations>
            <Annotations Target="CatalogService.Authors/IsActiveEntity">
                <Annotation Term="UI.Hidden" Bool="true"/>
            </Annotations>
            <Annotations Target="CatalogService.Authors/HasActiveEntity">
                <Annotation Term="UI.Hidden" Bool="true"/>
            </Annotations>
            <Annotations Target="CatalogService.Authors/HasDraftEntity">
                <Annotation Term="UI.Hidden" Bool="true"/>
            </Annotations>
            <Annotations Target="CatalogService.Authors/DraftAdministrativeData">
                <Annotation Term="UI.Hidden" Bool="true"/>
            </Annotations>
            <Annotations Target="CatalogService.EntityContainer/Users2Books">
                <Annotation Term="Common.DraftNode">
                    <Record Type="Common.DraftNodeType">
                        <PropertyValue Property="PreparationAction" String="CatalogService.draftPrepare"/>
                    </Record>
                </Annotation>
            </Annotations>
            <Annotations Target="CatalogService.Users2Books/createdAt">
                <Annotation Term="Core.Computed" Bool="true"/>
            </Annotations>
            <Annotations Target="CatalogService.Users2Books/IsActiveEntity">
                <Annotation Term="UI.Hidden" Bool="true"/>
            </Annotations>
            <Annotations Target="CatalogService.Users2Books/HasActiveEntity">
                <Annotation Term="UI.Hidden" Bool="true"/>
            </Annotations>
            <Annotations Target="CatalogService.Users2Books/HasDraftEntity">
                <Annotation Term="UI.Hidden" Bool="true"/>
            </Annotations>
            <Annotations Target="CatalogService.Users2Books/DraftAdministrativeData">
                <Annotation Term="UI.Hidden" Bool="true"/>
            </Annotations>
            <Annotations Target="CatalogService.EntityContainer/Authors2Books">
                <Annotation Term="Common.DraftNode">
                    <Record Type="Common.DraftNodeType">
                        <PropertyValue Property="PreparationAction" String="CatalogService.draftPrepare"/>
                    </Record>
                </Annotation>
            </Annotations>
            <Annotations Target="CatalogService.Authors2Books/IsActiveEntity">
                <Annotation Term="UI.Hidden" Bool="true"/>
            </Annotations>
            <Annotations Target="CatalogService.Authors2Books/HasActiveEntity">
                <Annotation Term="UI.Hidden" Bool="true"/>
            </Annotations>
            <Annotations Target="CatalogService.Authors2Books/HasDraftEntity">
                <Annotation Term="UI.Hidden" Bool="true"/>
            </Annotations>
            <Annotations Target="CatalogService.Authors2Books/DraftAdministrativeData">
                <Annotation Term="UI.Hidden" Bool="true"/>
            </Annotations>
            <Annotations Target="CatalogService.DraftAdministrativeData">
                <Annotation Term="Common.Label" String="{i18n>Draft_DraftAdministrativeData}"/>
                </Annotations>
                <Annotations Target="CatalogService.DraftAdministrativeData/DraftUUID">
                    <Annotation Term="UI.Hidden" Bool="true"/>
                    <Annotation Term="Common.Label" String="{i18n>Draft_DraftUUID}"/>
                    </Annotations>
                    <Annotations Target="CatalogService.DraftAdministrativeData/CreationDateTime">
                        <Annotation Term="Common.Label" String="{i18n>Draft_CreationDateTime}"/>
                        </Annotations>
                        <Annotations Target="CatalogService.DraftAdministrativeData/CreatedByUser">
                            <Annotation Term="Common.Label" String="{i18n>Draft_CreatedByUser}"/>
                            </Annotations>
                            <Annotations Target="CatalogService.DraftAdministrativeData/DraftIsCreatedByMe">
                                <Annotation Term="UI.Hidden" Bool="true"/>
                                <Annotation Term="Common.Label" String="{i18n>Draft_DraftIsCreatedByMe}"/>
                                </Annotations>
                                <Annotations Target="CatalogService.DraftAdministrativeData/LastChangeDateTime">
                                    <Annotation Term="Common.Label" String="{i18n>Draft_LastChangeDateTime}"/>
                                    </Annotations>
                                    <Annotations Target="CatalogService.DraftAdministrativeData/LastChangedByUser">
                                        <Annotation Term="Common.Label" String="{i18n>Draft_LastChangedByUser}"/>
                                        </Annotations>
                                        <Annotations Target="CatalogService.DraftAdministrativeData/InProcessByUser">
                                            <Annotation Term="Common.Label" String="{i18n>Draft_InProcessByUser}"/>
                                            </Annotations>
                                            <Annotations Target="CatalogService.DraftAdministrativeData/DraftIsProcessedByMe">
                                                <Annotation Term="UI.Hidden" Bool="true"/>
                                                <Annotation Term="Common.Label" String="{i18n>Draft_DraftIsProcessedByMe}"/>
                                                </Annotations>
                                            </Schema>
                                        </edmx:DataServices>
                                    </edmx:Edmx>